org.eclipse.viatra.query.runtime.matchers.psystem.rewriters

## Class AbstractRewriterTraceSource

- java.lang.Object
- - org.eclipse.viatra.query.runtime.matchers.psystem.rewriters.AbstractRewriterTraceSource

- Direct Known Subclasses:
    PBodyCopier, PDisjunctionRewriter

      public class AbstractRewriterTraceSource
      extends java.lang.Object

  Since:
    1.6

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractRewriterTraceSource()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `addTrace(PTraceable original, PTraceable derivative)` Mark the given derivative to be originated from the given original constraint.
    `protected void` | `derivativeRemoved(PConstraint derivative, IDerivativeModificationReason reason)` Indicate that the given derivative is removed from the resulting query, thus its trace information should be removed also.
    `protected IRewriterTraceCollector` | `getTraceCollector()`
    `IPTraceableTraceProvider` | `getTraces()`
    `void` | `setTraceCollector(IRewriterTraceCollector traceCollector)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractRewriterTraceSource

          public AbstractRewriterTraceSource()

  - ### Method Detail

    - #### setTraceCollector

          public void setTraceCollector(IRewriterTraceCollector traceCollector)

    - #### getTraces

          public IPTraceableTraceProvider getTraces()

    - #### getTraceCollector

          protected IRewriterTraceCollector getTraceCollector()

    - #### addTrace

          protected void addTrace(PTraceable original,
                                  PTraceable derivative)

      Mark the given derivative to be originated from the given original constraint.
      Since:
        1.6

    - #### derivativeRemoved

          protected void derivativeRemoved(PConstraint derivative,
                                           IDerivativeModificationReason reason)

      Indicate that the given derivative is removed from the resulting query, thus its trace information should be removed also.
      Since:
        1.6